----------------------------------------------------------------------------
-- LBL - WISCONSIN
-- ATLAS ROD ELECTRONICS
----------------------------------------------------------------------------
-- Filename:
--    dsp2_sink.vhd
-- Description:
--    Gathers the Router Output Data
--
----------------------------------------------------------------------------

library IEEE ;
use IEEE.STD_LOGIC_1164.all ;
use IEEE.std_logic_arith.all;

----------------------------------------------------------------------------
--PORT DECLARATION
----------------------------------------------------------------------------

ENTITY dsp2_sink IS
  port (
      clk80            : in  STD_LOGIC ;
      dsp_send_data_in : in  STD_LOGIC ;
      dsp_data_in      : in  STD_LOGIC_VECTOR (31 DOWNTO 0)
      ) ;
END  dsp2_sink;

architecture rtl of dsp2_sink is

----------------------------------------------------------------------------
--SIGNAL DECLARATION
----------------------------------------------------------------------------

signal word_count : integer := 0;

----------------------------------------------------------------------------
--COMPONENT DECLARATION
----------------------------------------------------------------------------
  
BEGIN  --  Main Body of VHDL code

router_out: process (clk80)
    type save_file_type is file of character;
    file save_file: save_file_type is
      out "C:\work\Atlas\ROD\fpgaDesigns\rod_revF\rtr\vhdl\current\TestBench\output\dsp2_output.txt";
    variable i: integer;
  begin
    if (clk80'event and clk80 = '1') then
      if (dsp_send_data_in = '0') then
        for i in 31 downto 0 loop
--          if (i = 15 OR i = 31) then
          if (i = 31) then
            write (save_file, ' ');
          end if;
          if (dsp_data_in(i) = '1') then
            write (save_file, '1');
          else
            write (save_file, '0');
          end if;
        end loop;
        word_count <= word_count + 1;
      end if;
    end if;  
end process;

END rtl;

