----------------------------------------------------------------------------
-- LBL - WISCONSIN
-- ATLAS ROD ELECTRONICS
----------------------------------------------------------------------------
-- Filename:
--    fifo_test_reader.vhd
-- Description:
--    Simulates a gatherer's read commands to the fifo controller to
--    test it.
----------------------------------------------------------------------------

library IEEE ;
use IEEE.STD_LOGIC_1164.all ;
use IEEE.std_logic_arith.all;

----------------------------------------------------------------------------
--PORT DECLARATION
----------------------------------------------------------------------------

ENTITY dbg_bits_sink IS
  port (
      clk             : in  STD_LOGIC ;
      data_valid      : in  STD_LOGIC ;
      data            : in  STD_LOGIC_VECTOR (55 DOWNTO 0) 
      ) ;
END  dbg_bits_sink;

architecture rtl of dbg_bits_sink is

----------------------------------------------------------------------------
--SIGNAL DECLARATION
----------------------------------------------------------------------------

signal word_count : integer := 0;

----------------------------------------------------------------------------
--COMPONENT DECLARATION
----------------------------------------------------------------------------
  
BEGIN  --  Main Body of VHDL code

rod_out: process (clk)
    type save_file_type is file of character;
    file save_file: save_file_type is
      out "/home/edafiles/atlas/rod/fpga_code/formatter_sct/simulation_output_files/efb_output.txt";
    variable i: integer;
  begin
    if (clk'event and clk = '1') then
      if (data_valid = '1') then
        for i in 55 downto 0 loop
          if (i = 15 OR i = 31) then
            write (save_file, ' ');
          end if;
          if (data(i) = '1') then
            write (save_file, '1');
          else
            write (save_file, '0');
          end if;
        end loop;
        write (save_file, lf);
	word_count <= word_count + 1;
      end if;
    end if;  
end process;

END rtl;

