----------------------------------------------------------------------------
-- LBL - WISCONSIN
-- ATLAS ROD ELECTRONICS
----------------------------------------------------------------------------
-- Filename:
--    slink_sink.vhd
-- Description:
--    Gathers the Router Output Data
--
----------------------------------------------------------------------------

library IEEE ;
use IEEE.STD_LOGIC_1164.all ;
use IEEE.std_logic_arith.all;

----------------------------------------------------------------------------
--PORT DECLARATION
----------------------------------------------------------------------------

ENTITY slink_sink IS
  port (
      clk               : in  STD_LOGIC ;
      slink_wen_n_in    : in  STD_LOGIC ;
      slink_uctrl_n_in  : in  STD_LOGIC ;
      slink_data_in     : in  STD_LOGIC_VECTOR (31 DOWNTO 0)
      ) ;
END  slink_sink;

architecture rtl of slink_sink is

----------------------------------------------------------------------------
--SIGNAL DECLARATION
----------------------------------------------------------------------------

signal word_count : integer := 0;

----------------------------------------------------------------------------
--COMPONENT DECLARATION
----------------------------------------------------------------------------
  
BEGIN  --  Main Body of VHDL code

router_out: process (clk)
    type save_file_type is file of character;
    file save_file: save_file_type is
      out "/home/edafiles/atlas/rod/fpga_code/router/simulation_output_files/router_output.txt";
    variable i: integer;
  begin
    if (clk'event and clk = '1') then
      if (slink_wen_n_in = '0') then
        for i in 31 downto 0 loop
          if (i = 15 OR i = 31) then
            write (save_file, ' ');
          end if;
          if (slink_data_in(i) = '1') then
            write (save_file, '1');
          else
            write (save_file, '0');
          end if;
        end loop;
        write (save_file, ' ');
        if (slink_uctrl_n_in = '1') then
            write (save_file, '1');
        else
            write (save_file, '0');
        end if;
        write (save_file, lf);
	word_count <= word_count + 1;
      end if;
    end if;  
end process;

END rtl;

